"""
Django settings for retouchmaster project.

Generated by 'django-admin startproject' using Django 4.2.5.

For more information on this file, see
https://docs.djangoproject.com/en/4.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.2/ref/settings/
"""

from pathlib import Path
import os
from dotenv import load_dotenv
load_dotenv()

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get("DJANGO_SECRET_KEY")

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = []

ENV_ALLOWED_HOSTS = os.environ.get("ENV_ALLOWED_HOSTS")
ENV_ALLOWED_CORS = os.environ.get("ENV_ALLOWED_CORS")
ENV_ALLOWED_ORIGIN_REGEXES = os.environ.get("ENV_ALLOWED_ORIGIN_REGEXES")
ENV_ALLOWED_HOSTS = ENV_ALLOWED_HOSTS.split(",")
ENV_ALLOWED_CORS = ENV_ALLOWED_CORS.split(",")
ENV_ALLOWED_ORIGIN_REGEXES = ENV_ALLOWED_ORIGIN_REGEXES.split(",")
ALLOWED_HOSTS = ENV_ALLOWED_HOSTS
# CORS_ALLOWED_ORIGINS = ENV_ALLOWED_CORS
CORS_ALLOWED_ORIGIN_REGEXES = ENV_ALLOWED_ORIGIN_REGEXES

# Add
CORS_ALLOWED_ORIGINS = [
    "http://localhost:8001", "https://retouchmaster.com", "https://api.retouchmaster.com:4433"
]
CORS_ALLOW_METHODS = ["GET", "POST", "PUT", "DELETE"]
CORS_ALLOW_CREDENTIALS = True


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    "rest_framework.authtoken",
    "rest_framework",
    "drf_yasg",
    "corsheaders",
    "account",
    "service",
    "quote",
    "trial",
    "contact",
    "feedback",
    "answerquestion",
    "post",
    "product",
    "menu",
    "processes",
    "pricing",
    "document",
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

REST_FRAMEWORK = {
    "DEFAULT_FILTER_BACKENDS": ["django_filters.rest_framework.DjangoFilterBackend"],
    "DEFAULT_PAGINATION_CLASS": "rest_framework.pagination.PageNumberPagination",
    "PAGE_SIZE": 30,
    
    "DEFAULT_AUTHENTICATION_CLASSES": [
        "rest_framework.authentication.TokenAuthentication",  
        "rest_framework.authentication.BasicAuthentication",
        "rest_framework.authentication.SessionAuthentication",
    ],
}

ROOT_URLCONF = 'retouchmaster.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        "DIRS": [os.path.join(BASE_DIR, "html")],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'retouchmaster.wsgi.application'


# Database
# https://docs.djangoproject.com/en/4.2/ref/settings/#databases

DATABASES = {
    'default': {
        "ENGINE": "django.db.backends.postgresql_psycopg2",
		"NAME": os.environ.get("POSTGRES_DB"),
		"USER": os.environ.get("POSTGRES_USER"),
		"PASSWORD": os.environ.get("POSTGRES_PASSWORD"),
		"HOST": os.environ.get("POSTGRES_HOST"),
		"PORT": os.environ.get("POSTGRES_PORT"),
    }
}


# Password validation
# https://docs.djangoproject.com/en/4.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = "Asia/Ho_Chi_Minh"

USE_I18N = True

USE_TZ = True

SWAGGER_SETTINGS = {
	"SECURITY_DEFINITIONS": {
		"Token": {
			"type": "apiKey",
			"name": "Authorization",
			"in": "header"
		}
	},
	"USE_SESSION_AUTH": False,
	"FORCE_SCRIPT_NAME": "/",
}

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.2/howto/static-files/

STATIC_URL = 'static/'
STATIC_ROOT = os.path.join(BASE_DIR, "static")


# Default primary key field type
# https://docs.djangoproject.com/en/4.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'
AUTH_USER_MODEL = "account.Account"

DEFAULT_FILE_STORAGE = "b2_storage.storage.B2Storage"
BACKBLAZEB2_APP_KEY_ID = os.environ.get("BACKBLAZEB2_APP_KEY_ID")
BACKBLAZEB2_APP_KEY = os.environ.get("BACKBLAZEB2_APP_KEY")
BACKBLAZEB2_BUCKET_NAME = os.environ.get("BACKBLAZEB2_BUCKET_NAME")
BACKBLAZEB2_BUCKET_ID = os.environ.get("BACKBLAZEB2_BUCKET_ID")
BACKBLAZEB2_ACCOUNT_ID = os.environ.get("BACKBLAZEB2_ACCOUNT_ID")

DATA_UPLOAD_MAX_MEMORY_SIZE = None

EMAIL_BACKEND = "django.core.mail.backends.smtp.EmailBackend"
EMAIL_HOST = os.environ.get("EMAIL_HOST")
EMAIL_USE_TLS = os.environ.get("EMAIL_USE_TLS")
EMAIL_PORT = os.environ.get("EMAIL_PORT")
EMAIL_HOST_USER = os.environ.get("EMAIL_HOST_USER")
EMAIL_HOST_PASSWORD = os.environ.get("EMAIL_HOST_PASSWORD")

KEY_FCM = os.environ.get("KEY_FCM")

firebaseConfig = {
    "apiKey": os.environ.get("ApiKey"),
    "authDomain": os.environ.get("AuthDomain"),
    "databaseURL": os.environ.get("DatabaseURL"),
    "projectId": os.environ.get("ProjectId"),
    "storageBucket": os.environ.get("StorageBucket"),
    "messagingSenderId": os.environ.get("MessagingSenderId"),
    "appId": os.environ.get("AppId"),
    "measurementId": os.environ.get("MeasurementId")
}